#include <WinAPI.au3>
#include <WinAPIFiles.au3>
#include <WinAPIProc.au3>
#include <Date.au3>

#Region Globale Einstellungen (Konstanten und son zeugs)
HotKeySet("^!q", _Ende)
OnAutoItExitRegister(_Ende)

Global Const $tag_MySharedStruct = "LONG NProcMax; LONG NProcesses;LONG Success" ; Aufbau des shared-Memory
Global Const $h_dll_Kernel32 = DllOpen("kernel32.dll")

; Mutex fr den gesamten Shared-Memory
$h_Mutex_SharedStruct = _WinAPI_CreateMutex("s_Mutex_SharedStruct", False)
#EndRegion Globale Einstellungen (Konstanten und son zeugs)


#Region shared memory erstellen oder ffnen
Global Const $s_FileMappingName = "HashCrackAutoIt_SharedMemory"
Global $h_Mapping = _WinAPI_OpenFileMapping($s_FileMappingName, $FILE_MAP_READ + $FILE_MAP_WRITE)
If Not $h_Mapping Then ; Master
	Global $h_Mapping = _WinAPI_CreateFileMapping(-1, DllStructGetSize(DllStructCreate($tag_MySharedStruct)), $s_FileMappingName, 0x4)
	If Not $h_Mapping Or @extended Then Exit MsgBox(0, "", "Konnte Shared-Memory nicht erstellen")
	Global $p_shared = _WinAPI_MapViewOfFile($h_Mapping) ; Pointer zum Shared-Memory
	Global $strct_Shared = DllStructCreate($tag_MySharedStruct, $p_shared)
	DllStructSetData($strct_Shared, "NProcesses", 0)

	; Anzahl an Prozessen (=Anzahl an HT-Cores um 100%-Auslastung zu erreichen)
	Global $d_NProcesses = ObjGet("winmgmts:\\127.0.0.1\root\CIMV2").ExecQuery("SELECT * FROM Win32_Processor", "WQL", 16).ItemIndex(0).NumberOfLogicalProcessors
	DllStructSetData($strct_Shared, "NProcMax", $d_NProcesses)
Else
	Global $p_shared = _WinAPI_MapViewOfFile($h_Mapping) ; Pointer zum Shared-Memory
	Global $strct_Shared = DllStructCreate($tag_MySharedStruct, $p_shared)
	Global $d_NProcesses = DllStructGetData($strct_Shared, "NProcMax")
EndIf

; Prozesszhler erhhen
Global $d_ProcessID = _atomic_Increment($strct_Shared, "NProcesses") - 1
#EndRegion shared memory erstellen oder ffnen


#Region Master-Prozess
If $d_ProcessID = 0 Then ; Master-Process (verwaltet lediglich die Slaves)
	Global $a_ProcessIDs[$d_NProcesses]

	; Slave-Prozesse starten
	For $i = 1 To $d_NProcesses
		$a_ProcessIDs[$i - 1] = Run(@Compiled ? @ScriptFullPath : '"' & @AutoItExe & '" "' & @ScriptFullPath & '"')
		ProcessWait($a_ProcessIDs[$i - 1])
	Next

	Do
		Sleep(100)
;~ 		; Falls ein Slave Success gemeldet hat:
		If DllStructGetData($strct_Shared, "Success") > 0 Then
			For $d_PID In $a_ProcessIDs
				ProcessClose($d_PID)
			Next
			_Ende()
		EndIf
	Until DllStructGetData($strct_Shared, "NProcesses") = 1
	#EndRegion Master-Prozess

Else ; Slave-Process
	#Region Slave-Prozess
	Global $tag_MD5_CTX = "dword i[2];dword buf[4];ubyte in[64];ubyte digest[16]"
	Global $h_dll_advapi32 = DllOpen("advapi32.dll")

	Global $strct_CTX_1 = DllStructCreate($tag_MD5_CTX)
	Global $strct_CTX_2 = DllStructCreate($tag_MD5_CTX)
	Global $d_CTX_Size = DllStructGetSize($strct_CTX_1)
	Global $ptr_CTX_1 = DllStructGetPtr($strct_CTX_1)
	Global $ptr_CTX_2 = DllStructGetPtr($strct_CTX_2)

	Global $bin_Result = Binary("0x" & FileReadLine("hash.txt")) ; der zu checkende Hash
	Global $a_Words = FileReadToArray("wordlist.txt")

	Global $d_Step = Floor(@extended / $d_NProcesses)
	Global $d_Start = $d_Step * ($d_ProcessID - 1)

	; Log-File fr den Zwischenstand
	Global $h_File = FileOpen($d_ProcessID & ".txt", 2)

	For $i = $d_Start To $d_Start + $d_Step - 1
		; ersten Teil hashen:
		DllCall($h_dll_advapi32, "none", "MD5Init", "ptr", $ptr_CTX_1)
		DllCall($h_dll_advapi32, "none", "MD5Update", "ptr", $ptr_CTX_1, "str", $a_Words[$i], "dword", StringLen($a_Words[$i]))
		Global $bin_Data_1 = DllStructGetData(DllStructCreate("byte[" & $d_CTX_Size & "]", $ptr_CTX_1), 1)

		FileWriteLine($h_File, _NowTime(5) & @TAB & $a_Words[$i]) ; Logging

		For $j = 0 To UBound($a_Words) - 1
			; hash kopieren
			DllStructSetData(DllStructCreate("byte[" & $d_CTX_Size & "]", $ptr_CTX_2), 1, $bin_Data_1)
			DllCall($h_dll_advapi32, "none", "MD5Update", "ptr", $ptr_CTX_2, "str", $a_Words[$j], "dword", StringLen($a_Words[$j]))
			DllCall($h_dll_advapi32, "none", "MD5Final", "ptr", $ptr_CTX_2)

			If DllStructGetData($strct_CTX_2, 4) = $bin_Result Then
				MsgBox(0, "", $a_Words[$i] & @CRLF & $a_Words[$j])
				; Erfolg melden
				_atomic_Increment($strct_Shared, "Success")
			EndIf
		Next
	Next
EndIf
#EndRegion Slave-Prozess


; Funktion welche beim beenden alles sauber schlieen (soll)
Func _Ende()
	_WinAPI_UnmapViewOfFile($p_shared)
	_WinAPI_CloseHandle($h_Mutex_SharedStruct)

	If $d_ProcessID > 0 Then
		FileClose($h_File)
	Else
		For $d_PID In $a_ProcessIDs
			ProcessClose($d_PID)
		Next
		_WinAPI_CloseHandle($h_Mapping)
	EndIf
	; Da der Prozess beendet wird, den Threadzhler wieder um eins verringern:
	_atomic_Decrement($strct_Shared, "NProcesses")
	Exit
EndFunc   ;==>_Ende


; atomares inkrementieren auf eine Integervariable in einer Struktur
Func _atomic_Increment(ByRef $strct, Const $num)
	Local $d_Ret
	If @AutoItX64 Then
		_WinAPI_WaitForSingleObject($h_Mutex_SharedStruct)
		$d_Ret = DllStructGetData($strct, $num) + 1
		DllStructSetData($strct, $num, $d_Ret)
		_WinAPI_ReleaseMutex($h_Mutex_SharedStruct)
	Else
		$d_Ret = DllCall("Kernel32.dll", "Long", "InterlockedIncrement", "ptr", DllStructGetPtr($strct, $num))[0]
	EndIf
	Return $d_Ret
EndFunc   ;==>_atomic_Increment

; atomares dekrementieren auf eine Integervariable in einer Struktur
Func _atomic_Decrement(ByRef $strct, Const $num)
	Local $d_Ret
	If @AutoItX64 Then
		_WinAPI_WaitForSingleObject($h_Mutex_SharedStruct)
		$d_Ret = DllStructGetData($strct, $num) - 1
		DllStructSetData($strct, $num, $d_Ret)
		_WinAPI_ReleaseMutex($h_Mutex_SharedStruct)
	Else
		$d_Ret = DllCall("Kernel32.dll", "Long", "InterlockedDecrement", "ptr", DllStructGetPtr($strct, $num))[0]
	EndIf
	Return $d_Ret
EndFunc   ;==>_atomic_Decrement